> This page is for Afterpay Online Developer, version v1.
> For other versions, use one of these documentation indexes:
> - Main (default): https://developers.afterpay.com/afterpay-online-developer/main/llms.txt
> - v1: https://developers.afterpay.com/afterpay-online-developer/v-1/llms.txt
> - Chinese: https://developers.afterpay.com/afterpay-online-developer/chinese/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Reverse Payment

POST https://global-api-sandbox.afterpay.com/v1/payments/token:{token}/reversal/environment:{environment}

This endpoint performs a reversal of the checkout that is used to
initiate the Afterpay payment process. This will cancel the order
asynchronously as soon as it is created without the need of an
additional call to the void endpoint. In order for a payment to be
eligible, the order must be in a Captured state and must be issued
within 10 minutes of the order being created.

If this is called after a timeout is received from
[`v1/payments/capture`](Capture-Payment.v1.yaml/paths/~1v1~1payments~1capture/post), and `v1/payments/capture`
eventually completes successfully, the order will end up in a `REVERSED`
state. This is similar to a call to the
[`v1/payments/refund`](Create-Refund.v1.yaml/paths/~1v1~1payments~1\{orderId}~1refund) endpoint except that merchant
fees are not paid to Afterpay and the capture and refund will not show
up in the settlement file.

### Connection Timeouts

| Timeout | Time (Seconds) |
| ------- | -------------- |
| Open    | 10             |
| Read    | 70             |

Reference: https://developers.afterpay.com/afterpay-online-developer/api-reference/reference/payments/reverse-payment-by-token

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `environment` (string, required, default: api-sandbox) — Use `api-sandbox` for AU/NZ, or `api.us-sandbox` for US.
- `token` (string, required) — Order token that was used to complete payment.

### Headers

- `Accept` (string, optional, default: application/json)

## Response

### 204

The Reversal endpoint indicates a successful response with a 204 status code response. Returns no content in the response.

## Errors

### 402 Payment Required Error

Invalid Token

- `any`

### 412 Precondition Failed Error

| HTTP Status Code | errorCode | Description | | :-------------------------- | :-------------------- | :------------------------------------ | | Precondition Failed | `precondition_failed` | Payment reversal previously processed | | Precondition Failed | `precondition_failed` | Payment not eligible for a reversal | | Precondition Failed | `precondition_failed` | Order outside reversal window |

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox"

payload = {}
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v1/payments/token:token/reversal/environment:api-sandbox")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```